function [ y ] = Linear_Opr_Tensor( Alph,mode )

% The function Linear_Opr defines a linear operator for our tomographic 
% reconstruction formulation in the tensor form 
% which is used by the TFOCS solver.


% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

global C P D Nr_Blocks

[m,n,p] = size(D);
m_A=size(C,1);

switch mode,
    case 0,
       y={[n*Nr_Blocks,p], [m_A,1]};


    case 1,
    AL = reshape(Alph, n, Nr_Blocks , p);
    
    Z=tprod(D,AL);
    z=Z(:);
    IP=zeros(length(P),1);
    IP(P)=1:length(P);
    y=C*z(IP);
    
    case 2,
    z1 = C'*Alph;
    z =  z1(P); 
    Z = reshape(z, m, Nr_Blocks, p );
    Y = tprod(tran(D),Z);
    y=reshape(Y, n* Nr_Blocks, p );

end