function [ P ] = Perm_Vec( M,N,pattern_size )
% returns the permutaion vector which gives a permutation to the solution
% vector according to the blocks of size pattern_size(1) by pattern_size(2)
% in the image
%N       % how many pixels are in one rwo of the image-horizental size
%M       % how many pixels are in one column in the image -vertical size
% pattern_size(2)      % how many pixels are in one row of the pattern -
% horizental size
% pattern_size(1)      % how many pixels are in one column of the pattern 
% -vertical size
% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

P=zeros(N*M,1);
counter=1;
while counter<N*M+1
for i=1:(N/pattern_size(2))
    for l=1:(M/pattern_size(1))
        for k=1+(i-1)*pattern_size(2):pattern_size(2)+(i-1)*pattern_size(2)
            for j=1+(l-1)*pattern_size(1):pattern_size(1)+(l-1)...
                    *pattern_size(1)
                P(counter,1)=j+(k-1)*M;
                counter=counter+1;
            end
        end
    end
end
end
end